/*

Copyright 2015-2022 Igor Petrovic

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

*/

#ifdef HW_SUPPORT_USB

#include "board/Internal.h"
#include "tusb.h"
#include "core/src/MCU.h"

namespace Board::detail::USB
{
    void init()
    {
        auto descriptor = core::mcu::peripherals::usbDescriptor();
        descriptor->enableClock();

        for (size_t i = 0; i < descriptor->pins().size(); i++)
        {
            CORE_MCU_IO_INIT(descriptor->pins().at(i));
        }

        // disable VBUS sensing
        USB_OTG_FS->GCCFG |= USB_OTG_GCCFG_NOVBUSSENS;

        tusb_init();
        Board::detail::registerUpdateHook(&tud_task);
    }
}    // namespace Board::detail::USB

#endif